# CustomNonbondedForce Class Reference

This class implements nonbonded interactions between particles. More...

`#include <CustomNonbondedForce.h>`

Inheritance diagram for CustomNonbondedForce:

List of all members.

## Classes

class | ExclusionInfo
| This is an internal class used to record information about an exclusion.
class | FunctionInfo
| This is an internal class used to record information about a tabulated function.
class | GlobalParameterInfo
| This is an internal class used to record information about a global parameter.
class | InteractionGroupInfo
| This is an internal class used to record information about an interaction group.
class | ParticleInfo
| This is an internal class used to record information about a particle.
class | PerParticleParameterInfo
| This is an internal class used to record information about a per-particle parameter.

## Public Types

enum | NonbondedMethod { NoCutoff = 0, CutoffNonPeriodic = 1, CutoffPeriodic = 2 }
| This is an enumeration of the different methods that may be used for handling long range nonbonded forces. More...

## Public Member Functions

| CustomNonbondedForce (const std::string &energy)
| Create a CustomNonbondedForce.
| CustomNonbondedForce (const CustomNonbondedForce &rhs)
| ~CustomNonbondedForce ()
int | getNumParticles () const
| Get the number of particles for which force field parameters have been defined.
int | getNumExclusions () const
| Get the number of particle pairs whose interactions should be excluded.
int | getNumPerParticleParameters () const
| Get the number of per-particle parameters that the interaction depends on.
int | getNumGlobalParameters () const
| Get the number of global parameters that the interaction depends on.
int | getNumTabulatedFunctions () const
| Get the number of tabulated functions that have been defined.
int | getNumFunctions () const
| Get the number of tabulated functions that have been defined.
int | getNumInteractionGroups () const
| Get the number of interaction groups that have been defined.
const std::string & | getEnergyFunction () const
| Get the algebraic expression that gives the interaction energy between two particles.
void | setEnergyFunction (const std::string &energy)
| Set the algebraic expression that gives the interaction energy between two particles.
NonbondedMethod | getNonbondedMethod () const
| Get the method used for handling long range nonbonded interactions.
void | setNonbondedMethod (NonbondedMethod method)
| Set the method used for handling long range nonbonded interactions.
double | getCutoffDistance () const
| Get the cutoff distance (in nm) being used for nonbonded interactions.
void | setCutoffDistance (double distance)
| Set the cutoff distance (in nm) being used for nonbonded interactions.
bool | getUseSwitchingFunction () const
| Get whether a switching function is applied to the interaction.
void | setUseSwitchingFunction (bool use)
| Set whether a switching function is applied to the interaction.
double | getSwitchingDistance () const
| Get the distance at which the switching function begins to reduce the interaction.
void | setSwitchingDistance (double distance)
| Set the distance at which the switching function begins to reduce the interaction.
bool | getUseLongRangeCorrection () const
| Get whether to add a correction to the energy to compensate for the cutoff and switching function.
void | setUseLongRangeCorrection (bool use)
| Set whether to add a correction to the energy to compensate for the cutoff and switching function.
int | addPerParticleParameter (const std::string &name)
| Add a new per-particle parameter that the interaction may depend on.
const std::string & | getPerParticleParameterName (int index) const
| Get the name of a per-particle parameter.
void | setPerParticleParameterName (int index, const std::string &name)
| Set the name of a per-particle parameter.
int | addGlobalParameter (const std::string &name, double defaultValue)
| Add a new global parameter that the interaction may depend on.
const std::string & | getGlobalParameterName (int index) const
| Get the name of a global parameter.
void | setGlobalParameterName (int index, const std::string &name)
| Set the name of a global parameter.
double | getGlobalParameterDefaultValue (int index) const
| Get the default value of a global parameter.
void | setGlobalParameterDefaultValue (int index, double defaultValue)
| Set the default value of a global parameter.
int | addParticle (const std::vector< double > &parameters)
| Add the nonbonded force parameters for a particle.
void | getParticleParameters (int index, std::vector< double > &parameters) const
| Get the nonbonded force parameters for a particle.
void | setParticleParameters (int index, const std::vector< double > &parameters)
| Set the nonbonded force parameters for a particle.
int | addExclusion (int particle1, int particle2)
| Add a particle pair to the list of interactions that should be excluded.
void | getExclusionParticles (int index, int &particle1, int &particle2) const
| Get the particles in a pair whose interaction should be excluded.
void | setExclusionParticles (int index, int particle1, int particle2)
| Set the particles in a pair whose interaction should be excluded.
void | createExclusionsFromBonds (const std::vector< std::pair< int, int > > &bonds, int bondCutoff)
| Identify exclusions based on the molecular topology.
int | addTabulatedFunction (const std::string &name, TabulatedFunction *function)
| Add a tabulated function that may appear in the energy expression.
const TabulatedFunction & | getTabulatedFunction (int index) const
| Get a const reference to a tabulated function that may appear in the energy expression.
TabulatedFunction & | getTabulatedFunction (int index)
| Get a reference to a tabulated function that may appear in the energy expression.
const std::string & | getTabulatedFunctionName (int index) const
| Get the name of a tabulated function that may appear in the energy expression.
int | addFunction (const std::string &name, const std::vector< double > &values, double min, double max)
| Add a tabulated function that may appear in the energy expression.
void | getFunctionParameters (int index, std::string &name, std::vector< double > &values, double &min, double &max) const
| Get the parameters for a tabulated function that may appear in the energy expression.
void | setFunctionParameters (int index, const std::string &name, const std::vector< double > &values, double min, double max)
| Set the parameters for a tabulated function that may appear in the energy expression.
int | addInteractionGroup (const std::set< int > &set1, const std::set< int > &set2)
| Add an interaction group.
void | getInteractionGroupParameters (int index, std::set< int > &set1, std::set< int > &set2) const
| Get the parameters for an interaction group.
void | setInteractionGroupParameters (int index, const std::set< int > &set1, const std::set< int > &set2)
| Set the parameters for an interaction group.
void | updateParametersInContext (Context &context)
| Update the per-particle parameters in a Context to match those stored in this Force object.

## Protected Member Functions

ForceImpl * | createImpl () const
| When a Context is created, it invokes this method on each Force in the System.

## Detailed Description

This class implements nonbonded interactions between particles.

Unlike NonbondedForce, the functional form of the interaction is completely customizable, and may involve arbitrary algebraic expressions and tabulated functions. It may depend on the distance between particles, as well as on arbitrary global and per-particle parameters. It also optionally supports periodic boundary conditions and cutoffs for long range interactions.

To use this class, create a CustomNonbondedForce object, passing an algebraic expression to the constructor that defines the interaction energy between each pair of particles. The expression may depend on r, the distance between the particles, as well as on any parameters you choose. Then call addPerParticleParameter() to define per-particle parameters, and addGlobalParameter() to define global parameters. The values of per-particle parameters are specified as part of the system definition, while values of global parameters may be modified during a simulation by calling Context::setParameter().

Next, call addParticle() once for each particle in the System to set the values of its per-particle parameters. The number of particles for which you set parameters must be exactly equal to the number of particles in the System, or else an exception will be thrown when you try to create a Context. After a particle has been added, you can modify its parameters by calling setParticleParameters(). This will have no effect on Contexts that already exist unless you call updateParametersInContext().

CustomNonbondedForce also lets you specify "exclusions", particular pairs of particles whose interactions should be omitted from force and energy calculations. This is most often used for particles that are bonded to each other.

As an example, the following code creates a CustomNonbondedForce that implements a 12-6 Lennard-Jones potential:

`CustomNonbondedForce* force = new CustomNonbondedForce("4*epsilon*((sigma/r)^12-(sigma/r)^6); sigma=0.5*(sigma1+sigma2); epsilon=sqrt(epsilon1*epsilon2)");`

This force depends on two parameters: sigma and epsilon. The following code defines these as per-particle parameters:

``

     force->addPerParticleParameter("sigma");
     force->addPerParticleParameter("epsilon");

The expression must be symmetric with respect to the two particles. It typically will only be evaluated once for each pair of particles, and no guarantee is made about which particle will be identified as "particle 1". In the above example, the energy only depends on the products sigma1*sigma2 and epsilon1*epsilon2, both of which are unchanged if the labels 1 and 2 are reversed. In contrast, if it depended on the difference sigma1-sigma2, the results would be undefined, because reversing the labels 1 and 2 would change the energy.

CustomNonbondedForce can operate in two modes. By default, it computes the interaction of every particle in the System with every other particle. Alternatively, you can restrict it to only a subset of particle pairs. To do this, specify one or more "interaction groups". An interaction group consists of two sets of particles that should interact with each other. Every particle in the first set interacts with every particle in the second set. For example, you might use this feature to compute a solute-solvent interaction energy, while omitting all interactions between two solute atoms or two solvent atoms.

To create an interaction group, call addInteractionGroup(). You may add as many interaction groups as you want. Be aware of the following:

- Exclusions are still taken into account, so the interactions between excluded pairs are omitted.
- Likewise, a particle will never interact with itself, even if it appears in both sets of an interaction group.
- If a particle pair appears in two different interaction groups, its interaction will be computed twice. This is sometimes useful, but be aware of it so you do not accidentally create unwanted duplicate interactions.
- If you do not add any interaction groups to a CustomNonbondedForce, it operates in the default mode where every particle interacts with every other particle.

When using a cutoff, by default the interaction is sharply truncated at the cutoff distance. Optionally you can instead use a switching function to make the interaction smoothly go to zero over a finite distance range. To enable this, call setUseSwitchingFunction(). You must also call setSwitchingDistance() to specify the distance at which the interaction should begin to decrease. The switching distance must be less than the cutoff distance. Of course, you could also incorporate the switching function directly into your energy expression, but there are several advantages to keeping it separate. It makes your energy expression simpler to write and understand. It allows you to use the same energy expression with or without a cutoff. Also, when using a long range correction (see below), separating out the switching function allows the correction to be calculated more accurately.

Another optional feature of this class is to add a contribution to the energy which approximates the effect of all interactions beyond the cutoff in a periodic system. When running a simulation at constant pressure, this can improve the quality of the result. Call setUseLongRangeCorrection() to enable it.

Computing the long range correction takes negligible work in each time step, but it does require an expensive precomputation at the start of the simulation. Furthermore, that precomputation must be repeated every time a global parameter changes (or when you modify per-particle parameters by calling updateParametersInContext()). This means that if parameters change frequently, the long range correction can be very slow. For this reason, it is disabled by default.

Expressions may involve the operators + (add), - (subtract), * (multiply), / (divide), and ^ (power), and the following functions: sqrt, exp, log, sin, cos, sec, csc, tan, cot, asin, acos, atan, sinh, cosh, tanh, erf, erfc, min, max, abs, step, delta. All trigonometric functions are defined in radians, and log is the natural logarithm. step(x) = 0 if x is less than 0, 1 otherwise. delta(x) = 1 if x is 0, 0 otherwise. The names of per-particle parameters have the suffix "1" or "2" appended to them to indicate the values for the two interacting particles. As seen in the above example, the expression may also involve intermediate quantities that are defined following the main expression, using ";" as a separator.

In addition, you can call addTabulatedFunction() to define a new function based on tabulated values. You specify the function by creating a TabulatedFunction object. That function can then appear in the expression.

## Member Enumeration Documentation

enum NonbondedMethod

This is an enumeration of the different methods that may be used for handling long range nonbonded forces.

Enumerator:

  NoCutoff | No cutoff is applied to nonbonded interactions. The full set of N^2 interactions is computed exactly. This necessarily means that periodic boundary conditions cannot be used. This is the default.
  CutoffNonPeriodic | Interactions beyond the cutoff distance are ignored.
  CutoffPeriodic | Periodic boundary conditions are used, so that each particle interacts only with the nearest periodic copy of each other particle. Interactions beyond the cutoff distance are ignored.

## Constructor & Destructor Documentation

CustomNonbondedForce | ( | const std::string & | energy | ) | `[explicit]`

Create a CustomNonbondedForce.

Parameters:

  | energy | an algebraic expression giving the interaction energy between two particles as a function of r, the distance between them, as well as any global and per-particle parameters

CustomNonbondedForce | ( | const CustomNonbondedForce & | rhs | ) |

~CustomNonbondedForce | ( |  | ) |

## Member Function Documentation

int addExclusion | ( | int | particle1,
|  | int | particle2 |
| ) |  |  |

Add a particle pair to the list of interactions that should be excluded.

In many cases, you can use createExclusionsFromBonds() rather than adding each exclusion explicitly.

Parameters:

  | particle1 | the index of the first particle in the pair
  | particle2 | the index of the second particle in the pair

Returns:
  the index of the exclusion that was added

int addFunction | ( | const std::string & | name,
|  | const std::vector< double > & | values,
|  | double | min,
|  | double | max |
| ) |  |  |

Add a tabulated function that may appear in the energy expression.

Deprecated:
  This method exists only for backward compatibility. Use addTabulatedFunction() instead.

int addGlobalParameter | ( | const std::string & | name,
|  | double | defaultValue |
| ) |  |  |

Add a new global parameter that the interaction may depend on.

Parameters:

  | name | the name of the parameter
  | defaultValue | the default value of the parameter

Returns:
  the index of the parameter that was added

int addInteractionGroup | ( | const std::set< int > & | set1,
|  | const std::set< int > & | set2 |
| ) |  |  |

Add an interaction group.

An interaction will be computed between every particle in set1 and every particle in set2.

Parameters:

  | set1 | the first set of particles forming the interaction group
  | set2 | the second set of particles forming the interaction group

Returns:
  the index of the interaction group that was added

int addParticle | ( | const std::vector< double > & | parameters | ) |

Add the nonbonded force parameters for a particle.

This should be called once for each particle in the System. When it is called for the i'th time, it specifies the parameters for the i'th particle.

Parameters:

  | parameters | the list of parameters for the new particle

Returns:
  the index of the particle that was added

int addPerParticleParameter | ( | const std::string & | name | ) |

Add a new per-particle parameter that the interaction may depend on.

Parameters:

  | name | the name of the parameter

Returns:
  the index of the parameter that was added

int addTabulatedFunction | ( | const std::string & | name,
|  | TabulatedFunction * | function |
| ) |  |  |

Add a tabulated function that may appear in the energy expression.

Parameters:

  | name | the name of the function as it appears in expressions
  | function | a TabulatedFunction object defining the function. The TabulatedFunction should have been created on the heap with the "new" operator. The Force takes over ownership of it, and deletes it when the Force itself is deleted.

Returns:
  the index of the function that was added

void createExclusionsFromBonds | ( | const std::vector< std::pair< int, int > > & | bonds,
|  | int | bondCutoff |
| ) |  |  |

Identify exclusions based on the molecular topology.

Particles which are separated by up to a specified number of bonds are added as exclusions.

Parameters:

  | bonds | the set of bonds based on which to construct exclusions. Each element specifies the indices of two particles that are bonded to each other.
  | bondCutoff | pairs of particles that are separated by this many bonds or fewer are added to the list of exclusions

ForceImpl* createImpl | ( |  | ) | const`[protected, virtual]`

When a Context is created, it invokes this method on each Force in the System.

It should create a new ForceImpl object which can be used by the context for calculating forces. The ForceImpl will be deleted automatically when the Context is deleted.

Implements Force.

double getCutoffDistance | ( |  | ) | const

Get the cutoff distance (in nm) being used for nonbonded interactions.

If the NonbondedMethod in use is NoCutoff, this value will have no effect.

Returns:
  the cutoff distance, measured in nm

const std::string& getEnergyFunction | ( |  | ) | const

Get the algebraic expression that gives the interaction energy between two particles.

void getExclusionParticles | ( | int | index,
|  | int & | particle1,
|  | int & | particle2 |
| ) |  |  | const

Get the particles in a pair whose interaction should be excluded.

Parameters:

  | index | the index of the exclusion for which to get particle indices
  | particle1 | the index of the first particle in the pair
  | particle2 | the index of the second particle in the pair

void getFunctionParameters | ( | int | index,
|  | std::string & | name,
|  | std::vector< double > & | values,
|  | double & | min,
|  | double & | max |
| ) |  |  | const

Get the parameters for a tabulated function that may appear in the energy expression.

Deprecated:
  This method exists only for backward compatibility. Use getTabulatedFunctionParameters() instead. If the specified function is not a Continuous1DFunction, this throws an exception.

double getGlobalParameterDefaultValue | ( | int | index | ) | const

Get the default value of a global parameter.

Parameters:

  | index | the index of the parameter for which to get the default value

Returns:
  the parameter default value

const std::string& getGlobalParameterName | ( | int | index | ) | const

Get the name of a global parameter.

Parameters:

  | index | the index of the parameter for which to get the name

Returns:
  the parameter name

void getInteractionGroupParameters | ( | int | index,
|  | std::set< int > & | set1,
|  | std::set< int > & | set2 |
| ) |  |  | const

Get the parameters for an interaction group.

Parameters:

  | index | the index of the interaction group for which to get parameters
  | set1 | the first set of particles forming the interaction group
  | set2 | the second set of particles forming the interaction group

NonbondedMethod getNonbondedMethod | ( |  | ) | const

Get the method used for handling long range nonbonded interactions.

int getNumExclusions | ( |  | ) | const`[inline]`

Get the number of particle pairs whose interactions should be excluded.

int getNumFunctions | ( |  | ) | const`[inline]`

Get the number of tabulated functions that have been defined.

Deprecated:
  This method exists only for backward compatibility. Use getNumTabulatedFunctions() instead.

int getNumGlobalParameters | ( |  | ) | const`[inline]`

Get the number of global parameters that the interaction depends on.

int getNumInteractionGroups | ( |  | ) | const`[inline]`

Get the number of interaction groups that have been defined.

int getNumParticles | ( |  | ) | const`[inline]`

Get the number of particles for which force field parameters have been defined.

int getNumPerParticleParameters | ( |  | ) | const`[inline]`

Get the number of per-particle parameters that the interaction depends on.

int getNumTabulatedFunctions | ( |  | ) | const`[inline]`

Get the number of tabulated functions that have been defined.

void getParticleParameters | ( | int | index,
|  | std::vector< double > & | parameters |
| ) |  |  | const

Get the nonbonded force parameters for a particle.

Parameters:

  | index | the index of the particle for which to get parameters
  | parameters | the list of parameters for the specified particle

const std::string& getPerParticleParameterName | ( | int | index | ) | const

Get the name of a per-particle parameter.

Parameters:

  | index | the index of the parameter for which to get the name

Returns:
  the parameter name

double getSwitchingDistance | ( |  | ) | const

Get the distance at which the switching function begins to reduce the interaction.

This must be less than the cutoff distance.

TabulatedFunction& getTabulatedFunction | ( | int | index | ) |

Get a reference to a tabulated function that may appear in the energy expression.

Parameters:

  | index | the index of the function to get

Returns:
  the TabulatedFunction object defining the function

const TabulatedFunction& getTabulatedFunction | ( | int | index | ) | const

Get a const reference to a tabulated function that may appear in the energy expression.

Parameters:

  | index | the index of the function to get

Returns:
  the TabulatedFunction object defining the function

const std::string& getTabulatedFunctionName | ( | int | index | ) | const

Get the name of a tabulated function that may appear in the energy expression.

Parameters:

  | index | the index of the function to get

Returns:
  the name of the function as it appears in expressions

bool getUseLongRangeCorrection | ( |  | ) | const

Get whether to add a correction to the energy to compensate for the cutoff and switching function.

This has no effect if periodic boundary conditions are not used.

bool getUseSwitchingFunction | ( |  | ) | const

Get whether a switching function is applied to the interaction.

If the nonbonded method is set to NoCutoff, this option is ignored.

void setCutoffDistance | ( | double | distance | ) |

Set the cutoff distance (in nm) being used for nonbonded interactions.

If the NonbondedMethod in use is NoCutoff, this value will have no effect.

Parameters:

  | distance | the cutoff distance, measured in nm

void setEnergyFunction | ( | const std::string & | energy | ) |

Set the algebraic expression that gives the interaction energy between two particles.

void setExclusionParticles | ( | int | index,
|  | int | particle1,
|  | int | particle2 |
| ) |  |  |

Set the particles in a pair whose interaction should be excluded.

Parameters:

  | index | the index of the exclusion for which to set particle indices
  | particle1 | the index of the first particle in the pair
  | particle2 | the index of the second particle in the pair

void setFunctionParameters | ( | int | index,
|  | const std::string & | name,
|  | const std::vector< double > & | values,
|  | double | min,
|  | double | max |
| ) |  |  |

Set the parameters for a tabulated function that may appear in the energy expression.

Deprecated:
  This method exists only for backward compatibility. Use setTabulatedFunctionParameters() instead. If the specified function is not a Continuous1DFunction, this throws an exception.

void setGlobalParameterDefaultValue | ( | int | index,
|  | double | defaultValue |
| ) |  |  |

Set the default value of a global parameter.

Parameters:

  | index | the index of the parameter for which to set the default value
  | name | the default value of the parameter

void setGlobalParameterName | ( | int | index,
|  | const std::string & | name |
| ) |  |  |

Set the name of a global parameter.

Parameters:

  | index | the index of the parameter for which to set the name
  | name | the name of the parameter

void setInteractionGroupParameters | ( | int | index,
|  | const std::set< int > & | set1,
|  | const std::set< int > & | set2 |
| ) |  |  |

Set the parameters for an interaction group.

Parameters:

  | index | the index of the interaction group for which to set parameters
  | set1 | the first set of particles forming the interaction group
  | set2 | the second set of particles forming the interaction group

void setNonbondedMethod | ( | NonbondedMethod | method | ) |

Set the method used for handling long range nonbonded interactions.

void setParticleParameters | ( | int | index,
|  | const std::vector< double > & | parameters |
| ) |  |  |

Set the nonbonded force parameters for a particle.

Parameters:

  | index | the index of the particle for which to set parameters
  | parameters | the list of parameters for the specified particle

void setPerParticleParameterName | ( | int | index,
|  | const std::string & | name |
| ) |  |  |

Set the name of a per-particle parameter.

Parameters:

  | index | the index of the parameter for which to set the name
  | name | the name of the parameter

void setSwitchingDistance | ( | double | distance | ) |

Set the distance at which the switching function begins to reduce the interaction.

This must be less than the cutoff distance.

void setUseLongRangeCorrection | ( | bool | use | ) |

Set whether to add a correction to the energy to compensate for the cutoff and switching function.

This has no effect if periodic boundary conditions are not used.

void setUseSwitchingFunction | ( | bool | use | ) |

Set whether a switching function is applied to the interaction.

If the nonbonded method is set to NoCutoff, this option is ignored.

void updateParametersInContext | ( | Context & | context | ) |

Update the per-particle parameters in a Context to match those stored in this Force object.

This method provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it. Simply call setParticleParameters() to modify this object's parameters, then call updateParametersInContext() to copy them over to the Context.

This method has several limitations. The only information it updates is the values of per-particle parameters. All other aspects of the Force (the energy function, nonbonded method, cutoff distance, etc.) are unaffected and can only be changed by reinitializing the Context. Also, this method cannot be used to add new particles, only to change the parameters of existing ones.

The documentation for this class was generated from the following file:

- CustomNonbondedForce.h